import { Room } from './room.js';
import { Inspectable } from './inspectable.js';

export class Door extends Inspectable {
	private readonly onOpenCallbacks = new Set<Parameters<HTMLElement['addEventListener']>[1]>();

	constructor(private nextRoom: Room) {
		super();
	}

	public get title() {
		return this.nextRoom.config.name;
	}

	public open() {
		return this.dispatchEvent(new CustomEvent('open', { cancelable: true }))
			? this.nextRoom.open()
			: super.open();
	}

	public onOpen(cb: (e: Event) => void) {
		this.onOpenCallbacks.add(cb);
		this.addEventListener('open', cb);
		return this;
	}
}
