import { Door } from './door.js';
import { Game } from './game.js';
import { Inspectable } from './inspectable.js';
import { Player } from './player.js';
import { Room } from './room.js';
import { Tile } from './tile.js';

export function defineCustomElements(...CustomElements: { prototype: HTMLElement; new(...args: any[]): HTMLElement; }[]) {
	for (const CustomElement of CustomElements) {
		globalThis.customElements.define(`z-${CustomElement.name.toLowerCase()}`, CustomElement);
	}
}

export function bootstrap() {
	defineCustomElements(
		Door,
		Game,
		Inspectable,
		Player,
		Room,
		Tile,
	);
}

export {
	Door,
	Game,
	Inspectable,
	Player,
	Room,
	Tile,
};

export { Camera } from './camera.js';
export { Config } from './config.js';
export { Inventory } from './inventory.js';
